import * as METADATA from './constants';

function injectable(): ClassDecorator {
  return <TFunction extends Function>(target: TFunction): TFunction | void => {

    if (Reflect.hasOwnMetadata(METADATA.PARAM_TYPES, target) === true) {
      throw new Error('Cannot apply @injectable decorator multiple times.');
    }

    let types = Reflect.getMetadata(METADATA.DESIGN_PARAM_TYPES, target) || [];
    Reflect.defineMetadata(METADATA.PARAM_TYPES, types, target);

    return target;
  };
}
